# Летняя школа DevOps/DevSecOps 2024
### Инструкция по подготовке к школе. Что нужно установить до начала тренингов, что мы будем изучать

**ВАЖНО:** подписывайтесь на [официальный канал](https://t.me/+IptjII5qlLg3YWEy) в телеграмм, чтобы не пропустить важную информацию

## Обновления
* добавлены ссылки на дни 1-3
* добавлены записи дни 4-5, материалы
* добавлены слайды день 5, день 6

## Темы

В рамках обучения мы рассматриваем следующие темы:

| Дата       | Тема                      | Трансляция                                                                                                                                        | Материалы                                                                                                                                                                                                        | Задание                                                                                                                                                                                                          | Преподаватель   | Срок       |
|------------|---------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------|------------|
| 19.08.2024 | Введение в контейнеры     | [vk](https://vk.com/video1097117_456239225), [rutube](https://rutube.ru/video/private/c07689fd2ef8c3c8ca4ea8b80895ea00/?p=Zp2Hy1WPZThLOR8FyJFSDg) | [слайды](https://docs.google.com/presentation/d/1neK04RyIcfwEI3e8bDpUWVquL435ONmlL-DTTe8npZo)                                                                                                                    | [тест](https://docs.google.com/forms/d/e/1FAIpQLSe_dhu7Dr4i5DOp7bw0IfBJKubnlG8IlxB2OZlBSwWZkd3cnA/viewform), [задание по созданию простого образа](https://git.miem.hse.ru/asshadrunov/day1/-/tree/master/day1)  | Шадрунов А. С.  | 26.08.2024 |
| 20.08.2024 | Безопасность контейнеров  | [vk](https://vk.com/video1097117_456239226), [rutube](https://rutube.ru/video/private/d7a579a9e61cb1655391c8f6a97dcb6d/?p=hTCfrT0JgqlkzCkyQo_Orw) | [слайды](https://docs.google.com/presentation/d/1UVj6zDyQ69JbIiyaNQy1AT05qIy2fcFzlFEvlL4Abe4)                                                                                                                    | [тест](https://docs.google.com/forms/d/e/1FAIpQLSf4kwtwlMAfBd8alQPqeZgnTfbcO_OY1iWdID-lU8kmGvKnKQ/viewform), [задание по сканеру образов](https://git.miem.hse.ru/asshadrunov/day1/-/tree/master/day2)           | Шадрунов А. С.  | 28.08.2024 |
| 21.08.2024 | Введение в DevOps         | [vk](https://vk.com/video1097117_456239227), [rutube](https://rutube.ru/video/private/a35e975be6c860767231707682dd08d5/?p=lnnNqS8FOBJr1PwqefgB1g) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day3_slides.pdf)                                                                                                             |                                                                                                                                                                                                                  | Бакин А. М.     |            |
| 22.08.2024 | Моделирование угроз       | [vk](https://vk.com/video1097117_456239228), [rutube](https://rutube.ru/video/private/e39334d970c47aa14e3514b171ef64ab/?p=14ByjnzDwHgHptKOBuJiNw) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day4_slides.pdf)                                                                                                             | [по желанию](https://t.me/c/2237255103/32)                                                                                                                                                                       | Бакин А. М.     | 06.09.2024 |
| 23.08.2024 | Безопасная разработка ПО  | [vk](https://vk.com/video1097117_456239229), [rutube](https://rutube.ru/video/private/b7a179fb99dc0e17d4b0bcf600796723/?p=Se318DBxS-ocpnzATd-_7A) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day5.1_slides.pdf), [слайды 2](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day5.2_slides.pdf) |                                                                                                                                                                                                                  | Елаев С. Ю.     |            |
| 26.08.2024 | Фреймворки зрелости SSDLC | [vk](https://vk.com/video1097117_456239230), [rutube](https://rutube.ru/video/private/0a63d10e955afa6ee0c3dda6144ecfe9/?p=26MUypY0kbJcJKLGXD1V4Q) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day6_slides.pdf)                                                                                                             | [задание](https://t.me/c/2237255103/37)                                                                                                                                                                          | Бакин А. М.     | 06.09.2024 |
| 27.08.2024 | Kubernetes - Введение | [vk](https://vk.com/video1097117_456239231), [rutube](https://rutube.ru/video/private/47cdd13c78227c50974762c44b6ca868/?p=_7IUU1-zQCO-HLBn40B3zA) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day7_slides.pdf)                                                                                                             | [задание](https://t.me/c/2237255103/42)                                                                                                                                                                          | Панасюк Е. В.     | 06.09.2024 |
| 28.08.2024 | Kubernetes - API, основные обьекты, контроллеры | [vk](https://vk.com/video1097117_456239232), [rutube](https://rutube.ru/video/private/2f42a657ae31e650156edb29587d938f/?p=Bdb1VsNlbmKz7q38FvmDLQ) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day8_slides.pdf)                                                                                                             |                                                                                                                                                                           | Панасюк Е. В.     |            |
| 29.08.2024 | Kubernetes - Сети | [vk](https://vk.com/video1097117_456239233), [rutube](https://rutube.ru/video/private/5984d129a7b7e57f19a238779a165b4f/?p=OCEbD0_Xy03LIvB_2dersQ) | [слайды](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day9_slides.pdf)                                                                                                             |  [задание](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/day9_task.pdf)                                                                                                             | Панасюк Е. В.     | 06.09.2024 |



## Цель обучения

Освоить современные практики непрерывной интеграции и доставки нового кода (Continuous Integration / Continuous Delivery, CI/CD) на примере технологий GitLab/GitFlow и Docker.

Участники разберутся с принципами CI/CD, научатся создавать пайплайны на примере Gitlab CI, освоят методы и инструменты контейнеризации на примере Docker, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование.

Слушатели получат понимание о современном жизненном цикле безопасной разработки приложений, приобретут навык работы с современными технологиями безопасного тестирования (SAST, DAST) тестирования, сканирования контейнеров и других механизмах безопасности, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование, а также научатся встраивать инструменты тестирования в безопасную цепочку поставки.



## Программа
Посмотреть программу школы [можно здесь](https://git.miem.hse.ru/devops_public/summerschool2024/-/blob/master/files/Programm_summer_DevOps_DevSecOps_2024.pdf)

В таблице ниже будут появляться ссылки на трансляции и дополнительные материалы

При выполнении заданий не забывайте пользоваться так же [справочными материалами](#полезные-ссылки-и-документация)

## Требования к участникам

Для прохождения летней школы не требуется сверх-навыков и подготовки, мы начинаем с достаточно базовых вещей.

Однако DevSecOps - это тема на стыке разработки, тестирования, администрирования и безопасности, поэтому некоторый бекграунд все же требуется.

Вы должны уметь работать с linux в командной строке и иметь базовые навыки администрирования. Вам придется устанавливать и настраивать необходимые инструмены для devops и работы с контейнерами.

Вы должны иметь базовые навыки разработки на каком то языке и точно должны уметь читать программный код.

Базовые навыки, такие как работа с системой контроля версий (git) и общее представление о gitflow, так же нужны.

Не стесняйтесь пользоваться [справочными материалами](#полезные-ссылки-и-документация), а так же загляните в раздел [самоподготовка](#самоподготовка)

## Самоподготовка

Чтобы помочь вам освежить базовые навыки, мы подготовили несколько дополнительных материалов.

### git

Инструменты совместной работы (git) является одной из тем, которые мы рассматриваем, но предполагается, что вы знаете основы работы с git.

Некоторые базовые вещи [разбираются в этом видео](https://youtu.be/U0yPHH72l1k)

Пожалуйста, ознакомьтесь с ним заранее, если у вас нет большого опыта работы с git.

Если у вас нет опыта командной работы, вы не знаете про ветки и gitflow (и у вас много свободного времени), можно так же посмотреть долгий материал [Основы Git. Основные операции. Мастер-класс «Ветвление в Git и управление ветками».](https://youtu.be/YyJBk5b9f7Q)

Вам так же надо будет установить клиент git на той платформе, где вы будете практиковаться. Как это сделать - см. раздел [необходимое ПО](#необходимое-по)

### docker

Вы пока не знаете ничего про докер, но вам нужно его поставить заранее (в том числе, чтобы пройти [стартовое тестирование](#стартовое-тестирование))
Если вы ранее не ставили себе docker, посмотрите небольшое [начальное видео](https://youtu.be/uZdH9yg9BQk)

## Стартовое тестирование

Пожалуйста, попробуйте свои силы и пройдите [стартовое тестирование](https://forms.yandex.ru/u/6496fdb73e9d086765be195b/)

Не пугайтесь, если не знаете как ответить на вопрос. В части вопросов по докеру, пожалуйста, ознакомьтесь с [начальным видео](https://youtu.be/uZdH9yg9BQk) и [установите себе на платформу докер](#тема-docker)

## Необходимые действия

1. Вам необходимо зарегистрироваться на платформе [GitLab (DevSecOps platform)](https://gitlab.com/)
  - [ ] Все задания, требующие использования репозитория и запуска CI/CD пайплайнов, будет делать на этой платформе.

2. Вам необходимо зарегистрироваться на  [Docker Hub](https://hub.docker.com/)
  - [ ] Сюда мы будет загружать полученные образы контейнеров.


## Необходимое ПО

Для выполнения практических заданий вам понадобится подготовить свой компьютер, установив на него необходимое программное обеспечение.

Мы рекомендуем использовать docker под ОС Linux (если у вас другая ОС, можно развернуть ее, например, в virtual box).
Общая рекомендация - для выполнения заданий поднимите виртуальную машину linux (например ubuntu) и в ней уже установите docker.

- [ ] Клиент git. [Интструкция по установке](#тема-git). 
- [ ] Docker (или другое CRI-совместимое решение). [Инструкция по установке](#тема-docker)
- [ ] Рекомендуем Вам установить Python3 и среду разработки к нему для выполнения домашних заданий.
    - Если Вы планируете использовать другой язык -- предустановите его
- [ ] gitlab-runner. Он вам понадобится ближе к третьему дню летней школы, но не забудьте его [установить и настроить](#установка-gitlab-runner).


### Учебные примеры

Учебные примеры с занятий доступны [здесь](https://git.miem.hse.ru/devops_public/examples/)

- [ ] Демо 1. [Простой пример](https://git.miem.hse.ru/devops_public/examples/demo1) упаковки питон приложения в контейнер 
- [ ] Демо 2. [Два примера веб-приложения](https://git.miem.hse.ru/devops_public/examples/demo2) в контейнер
- [ ] Демо 3. [Многоступенчатая сборка](https://git.miem.hse.ru/devops_public/examples/demo3) на примере простого go приложения
- [ ] Демо CI. [Учебный пример настройки pipeline](https://git.miem.hse.ru/devops_public/examples/demo-ci) разобранный на [лекции](https://youtube.com/live/LszI5cYJH68?feature=share)

### Полезные ссылки и документация

#### Материалы по Git

- Установка git client
    - [Установка Git](https://git-scm.com/book/ru/v2/%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5-%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0-Git) 
    - [Getting started](https://git-scm.com/book/en/v2/Getting-Started-Installing-Git) 
    - [Установка на windows](https://git-scm.com/download/win) 

- [Книга по Git. Много информации](https://git-scm.com/book/ru/v2/)

#### Материалы по Gitlab

- [Run GitLab Runner in a container](https://docs.gitlab.com/runner/install/docker.html)
- [Регистрация раннера](https://docs.gitlab.com/runner/register/index.html#docker)

#### Материалы по Docker

- [Основная документация Docker](https://docs.docker.com/)
- [Установка Docker](https://docs.docker.com/engine/install/)
- [Docker getting started](https://docs.docker.com/get-started/)
- [Справка по написанию Dockerfile](https://docs.docker.com/engine/reference/builder/)
- [Запуск команды в контейнере](https://docs.docker.com/engine/reference/commandline/run/)
- [Docker desktop под windows](https://docs.docker.com/desktop/install/windows-install/)
- [Контейнеры в Windows](https://learn.microsoft.com/ru-ru/virtualization/windowscontainers/quick-start/set-up-environment?tabs=Windows-Server)

#### Установка gitlab-runner

Пожалуйста, ознакомьтесь с [инструкцией](https://git.miem.hse.ru/devops_public/summerschool2023/-/blob/master/files/%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0%20%D1%80%D0%B0%D0%BD%D0%B5%D1%80%D0%B0.pdf) по утановке gitlab runner

Мы настоятельно рекомендует устанавливать раннер в контейнере docker, с подключением docker volume.
Так же пользуйтесь официальной документацией:
- [Установка раннера](https://docs.gitlab.com/runner/install/docker.html)
- [Регистрация раннера](https://docs.gitlab.com/runner/register/index.html#docker)
- [Docker in docker](https://gitlab-org.gitlab.io/gitlab-docs/ee/ci/docker/using_docker_build.html)


## Авторы
[В. Башун](mailto:vbashun@hse.ru), Т.Курмашева

## Контакты
- [ ] [Официальный канал Telegram](https://t.me/+5USjxpz4RU8yNTIy)
- [ ] Основной адрес электронной почты [vbashun@hse.ru](mailto:vbashun@hse.ru)
- [ ] Telegram: [@vbashun](https://t.me/vbashun)

## Contributing

Мы проводим летние/зимние школы, а так же учебные курсы по темам DevOps/DevSecOps.

Если у вас есть комментарии, замечания или предложения по доработке курсов, пожалуйста, [свяжитесь с нами](#контакты)

Если вы готовы сотрудничать или поучаствовать в разработке учебных программ или материалов, будем рады обсудить.


![photo_2023-07-21_19-01-33.jpg](pics%2Fphoto_2023-07-21_19-01-33.jpg)